from es import AddonInfo, ServerVar, tell
from cfglib import AddonCFG
from cmdlib import registerSayCommand, unregisterSayCommand
from spe import getPlayer, setLocVal, platform


info = AddonInfo()
info.name = 'Simple Resetscore'
info.version = 1.0
info.basename = 'simple_resetscore'
info.url = 'http://addons.eventscripts.com/addons/view/simple_resetscore'
info.author = 'Dead Man Walker'


def load():
   createCfg()
   for x in RS_COMMANDS:
      registerSayCommand(x, resetScore, "Resets ones score")

def unload():
   for x in RS_COMMANDS:
      unregisterSayCommand(x)

def es_map_start(event_var):
   createCfg()

def createCfg():
   global RS_COMMANDS, FRAGS_OFFSET, DEATHS_OFFSET, RS_MSG
   cfg = AddonCFG(ServerVar('eventscripts_gamedir') + "/cfg/" + info.basename + ".cfg")
   cfg.text("*****************************************************************")
   cfg.text("*** Simple Resetscore Config")
   cfg.text("*****************************************************************")
   cfg.text(' ')
   CFG_RS_COMMANDS = str(cfg.cvar('rs_commands', "!resetscore;!rs;resetscore;rs", 'Chat commands to reset ones score. Seperate with a semicolon (;)'))
   RS_MSG = str(cfg.cvar('rs_msg', "You have successfully reset your score!", "Chat message to player who has reset hie score"))
   RS_FRAGS_LINUX_OFFSET = int(cfg.cvar('rs_frags_linux_offset', 3332, "'m_iFrags' offset. May need to be updated upon updates. Ask/ see forums"))
   RS_DEATHS_LINUX_OFFSET = int(cfg.cvar('rs_deaths_linux_offset', 3336, "'m_iDeaths' offset. May need to be updated upon updates. Ask/ see forums"))
   cfg.text(' ')
   cfg.write()
   cfg.execute()

   RS_COMMANDS = CFG_RS_COMMANDS.strip().split(';')
   FRAGS_OFFSET = RS_FRAGS_LINUX_OFFSET - 20 if platform == "nt" else RS_FRAGS_LINUX_OFFSET
   DEATHS_OFFSET = RS_DEATHS_LINUX_OFFSET - 20 if platform == "nt" else RS_DEATHS_LINUX_OFFSET

def resetScore(userid, args):
   spePlayer = getPlayer(userid)
   setLocVal('i', spePlayer + FRAGS_OFFSET, 0)
   setLocVal('i', spePlayer + DEATHS_OFFSET, 0)
   if RS_MSG:
      tell(userid, '#multi', '#green[RESETSCORE]: #lightgreen' + RS_MSG)


